/*******************************************************************************
 * FoxSocialCategoryParty generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxSocialCategoryParty extends FoxSocialUICategoryBase within FoxSocialUI
    native(UI)
    config(UI);

enum EPartySocialTab
{
    EPST_PartyList,
    EPST_FriendList,
    EPST_ClanList,
    EPST_PlayerSearch,
    EPST_MAX
};

enum EPartyMemberClickMenuOption
{
    EPMCMO_OnlineProfile,
    EPMCMO_InviteGame,
    EPMCMO_JoinMatch,
    EPMCMO_Spectate,
    EPMCMO_AddClan,
    EPMCMO_AddFriend,
    EPMCMO_MAX
};

var FoxSocialCategoryParty.EPartySocialTab CurrentTab;
var FoxCacheParty PartyCache;
var private array<PartyDisplayInfo> CachedParty;
var string PartyListPath;
var const config string PartyMemberIconRef;
var const config string PartyLeaderIconRef;
var int ClickedMemberIndex;
var int RolledOverMemberIndex;
var bool bSocialContextOpen;
var int PrevSortByMethod;
var int PrevSortByMode;
var config int SortedByButtonAlpha;
var config int NonSortedByButtonAlpha;
var UniqueNetId ClickedUniqueId;
var GFxObject NameSortButton;
var GFxObject RankSortButton;
var transient array<ContextMenuEntry> ContextMenuEntries;

function Initialize()
{
    // End:0x138
    if((Outer.Outer.Outer.OnlineSub != none) && NotEqual_InterfaceInterface(Outer.Outer.Outer.OnlineSub.PartyInterface, (none)))
    {
        Outer.Outer.Outer.OnlineSub.PartyInterface.InitPartyMembers();
    }
    // End:0x18C
    if(class'FoxDataStore_StoreData'.static.GetCachedParty(PartyCache))
    {
        CachedParty = PartyCache.GetPartyList();
    }
    super.Initialize();
    Outer.as_AddSocialButtonContainer("PartyButtons", 0, 85, -18, 800, 175, false);
    as_PlaceSocialHorizLines("PartySub", 0, 24);
    Outer.Outer.Outer.Advance(0.0);
    ei_SetupPartyList();
    RefreshPartyList();
    //return;    
}

function ei_SetUpFriendsTab()
{
    Outer.RemoteSelectSocialCategory(Outer.FriendsCategory);
    //return;    
}

function ei_SetupClanTab()
{
    Outer.RemoteSelectSocialCategory(Outer.ClanCategory);
    //return;    
}

function ei_SetupPartyList()
{
    local string SortButtonPath;
    local GFxObject PartyListObject;

    CurrentTab = 0;
    Outer.as_AddSocialButtonContainer("sortButtons", 0, 177, 25, 800, 175, false);
    SortButtonPath = as_AddSocialSortButton("NameSortLabel", "NameSortTooltip", "ei_SortMembersByName");
    NameSortButton = Outer.Outer.Outer.GetVariableObject(SortButtonPath);
    SortButtonPath = as_AddSocialSortButton("LevelSortLabel", "LevelSortTooltip", "ei_SortMembersByRank");
    RankSortButton = Outer.Outer.Outer.GetVariableObject(SortButtonPath);
    as_AddSocialSortDivider(186, 2, 334);
    PartyListPath = as_AddPartyList(0, 0, "ei_PartyMemberClicked");
    PartyListObject = Outer.Outer.Outer.GetVariableObject(PartyListPath);
    Outer.Outer.Outer.Advance(0.0);
    // End:0x3F9
    if(PartyListObject != none)
    {
        // End:0x383
        if(class'WorldInfo'.static.IsConsoleBuild())
        {
            PartyListObject.SetString("rolloverFunction", "ei_MemberRolledOver");
            PartyListObject.SetString("sortLabel", Outer.Outer.Outer.ParseStringForCommands(LocStringSortPrompt));
        }
        // End:0x3F9
        else
        {
            PartyListObject.SetString("sortLabel", Outer.Outer.Outer.ParseStringForCommands(""));
        }
    }
    // End:0x485
    if(Outer.PartyTutorial != "")
    {
        Outer.Outer.Outer.ui_RunCommandGroup(Outer.PartyTutorial);
    }
    as_newFocusSocialSection();
    //return;    
}

function as_clearSocialButtonPrompts()
{
    Outer.Outer.Outer.ActionScriptVoid("_root.clearSocialButtonPrompts");
    //return;    
}

function ei_MemberRolledOver(int Index)
{
    // End:0x12
    if(CachedParty.Length == 0)
    {
        return;
    }
    as_clearSocialButtonPrompts();
    RolledOverMemberIndex = Index;
    // End:0x23C
    if((Index >= 0) && !bSocialContextOpen)
    {
        ClickedUniqueId = CachedParty[Index].UniqueId;
        as_AddInventoryButtonContainer("PartyRolloverSocialPrompts", 0, 475, 15, 800, 175, false);
        // End:0x217
        if((CachedParty[Index].OnlineStatus > 0) && CachedParty[Index].OnlineStatus != 1)
        {
            // End:0x167
            if(CachedParty[Index].bInvitedYou)
            {
                AddSocialButtonPrompt("AcceptInviteLabel_X");
            }
            // End:0x217
            else
            {
                // End:0x217
                if(((CachedParty[Index].OnlineStatus == 8) || CachedParty[Index].OnlineStatus == 10) && !CachedParty[Index].bRankedMatch)
                {
                    AddSocialButtonPrompt("JoinMatchLabel_X");
                }
            }
        }
        AddSocialButtonPrompt("ContextMenuActionOpen_X");
    }
    //return;    
}

function ei_PartyMemberClicked(int ClickMemberIndex)
{
    local bool bConsoleBuild, bIsLocalUser;
    local FoxItemCacheClan ClanCache;
    local FoxItemCacheFriends FriendCache;

    // End:0x12
    if(CachedParty.Length == 0)
    {
        return;
    }
    RefreshPartyList();
    bConsoleBuild = class'WorldInfo'.static.IsConsoleBuild();
    bIsLocalUser = false;
    ClickedMemberIndex = ClickMemberIndex;
    ClickedUniqueId = CachedParty[ClickMemberIndex].UniqueId;
    Outer.Outer.Outer.HideContextMenuWidget(ContextMenu);
    Outer.Outer.Outer.Advance(0.0);
    // End:0x2A3
    if((Outer.Outer.Outer.OnlineSub != none) && NotEqual_InterfaceInterface(Outer.Outer.Outer.OnlineSub.PlayerInterface, (none)))
    {
        bIsLocalUser = Outer.Outer.Outer.OnlineSub.PlayerInterface.GetPlayerNickname(0) == CachedParty[ClickedMemberIndex].sName;
    }
    ContextMenuEntries.Length = 0;
    as_AddInventoryButtonContainer("inventoryButtons", 0, 365, -12, 800, 175, false);
    // End:0x6FA
    if(!bIsLocalUser)
    {
        ApplyContextMenuEntry(0, "ViewOnlineProfileLabel", "ViewOnlineProfileLabelTooltip", bConsoleBuild);
        // End:0x3FD
        if(CanInvitePlayer())
        {
            // End:0x39F
            if(class'WorldInfo'.static.IsConsoleBuild(8))
            {
                ApplyContextMenuEntry(1, "GameInviteLabel", "GameInviteTooltip", true);
            }
            // End:0x3FD
            else
            {
                ApplyContextMenuEntry(1, "GameInviteLabel", "GameInviteTooltip", CachedParty[ClickMemberIndex].OnlineStatus != 0);
            }
        }
        ApplyContextMenuEntry(2, "JoinMatchLabel", "JoinMatchTooltip", ((CachedParty[ClickMemberIndex].OnlineStatus == 8) || CachedParty[ClickMemberIndex].OnlineStatus == 10) && !CachedParty[ClickMemberIndex].bRankedMatch);
        ApplyContextMenuEntry(3, "SpectateMatchLabel", "SpectateMatchTooltip", ((CachedParty[ClickMemberIndex].OnlineStatus == 8) || CachedParty[ClickMemberIndex].OnlineStatus == 10) && !CachedParty[ClickMemberIndex].bRankedMatch);
        ApplyContextMenuEntry(4, "AddClanLabel", "AddClanTooltip", (Outer.Outer.Outer.HasClanInvitePermission() && class'FoxDataStore_StoreData'.static.GetCachedClan(ClanCache)) && ClanCache.GetMemberIndexFromID(ClickedUniqueId) == -1);
        class'FoxDataStore_StoreData'.static.GetCachedFriends(FriendCache);
        ApplyContextMenuEntry(5, "addfriendlabel", "addfriendtooltip", (!bConsoleBuild && FriendCache != none) && FriendCache.GetFriendIndexFromID(ClickedUniqueId) == -1);
    }
    // End:0x7A9
    if(ContextMenuEntries.Length > 0)
    {
        Outer.Outer.Outer.ShowContextMenuWidget(ContextMenu, ContextMenuEntries, CachedParty[ClickMemberIndex].sName, "ei_partyMemberOptionClicked");
    }
    //return;    
}

function ei_RemovePartyMember()
{
    Outer.Outer.Outer.PartyInterface.RemovePartyMember(ClickedUniqueId);
    //return;    
}

function ei_LeaveParty()
{
    Outer.Outer.Outer.PartyInterface.RemovePartyMember(LocalPlayer(Outer.Outer.Outer.PCOwner.Player).GetUniqueNetId());
    //return;    
}

function ei_AcceptPartyInvite()
{
    Outer.Outer.Outer.PartyInterface.RespondToPartyInvite(true);
    //return;    
}

function ei_JoinPartyMemberGame()
{
    Outer.Outer.Outer.JoinGameByConnectString(CachedParty[ClickedMemberIndex].ConnectString, CachedParty[ClickedMemberIndex].Password != "");
    //return;    
}

simulated function SendPartyMemberGameInvite()
{
    local PlayerDisplayInfo DisplayInfo;

    Outer.Outer.Outer.PlayerInterface.SendGameInviteToFriend(0, CachedParty[ClickedMemberIndex].UniqueId);
    Outer.Outer.Outer.PumpSocialNotification(19, "", DisplayInfo.EmblemInfo);
    //return;    
}

function ei_AcceptPartyGameInvite()
{
    // End:0x150
    if(CachedParty[ClickedMemberIndex].bInvitedYou && (CachedParty[ClickedMemberIndex].OnlineStatus == 8) || CachedParty[ClickedMemberIndex].OnlineStatus == 10)
    {
        Outer.Outer.Outer.JoinGameByConnectString(CachedParty[ClickedMemberIndex].ConnectString, CachedParty[ClickedMemberIndex].Password != "", CachedParty[ClickedMemberIndex].Password);
    }
    //return;    
}

function ei_PromoteMember()
{
    Outer.Outer.Outer.PartyInterface.PromoteNewLeader(ClickedUniqueId);
    //return;    
}

function RefreshPartyList()
{
    local FoxItemCacheFriends FriendCache;
    local array<FriendDisplayInfo> CachedFriends;
    local int I, J;
    local string PartyLeaderName;
    local bool bIsPartyLeader;

    CachedParty = PartyCache.GetPartyList();
    // End:0x16A
    if((Outer.Outer.Outer.OnlineSub != none) && NotEqual_InterfaceInterface(Outer.Outer.Outer.OnlineSub.PartyInterface, (none)))
    {
        Outer.Outer.Outer.OnlineSub.PartyInterface.GetPartyLeaderName(PartyLeaderName);
    }
    I = 0;
    J0x175:
    // End:0x219 [Loop If]
    if(I < CachedParty.Length)
    {
        // End:0x20B
        if((CachedParty[I].sName == PartyLeaderName) && I > 0)
        {
            CachedParty.InsertItem(0, CachedParty[I]);
            CachedParty.Remove(I + 1, 1);
        }
        ++ I;
        // [Loop Continue]
        goto J0x175;
    }
    I = 0;
    J0x224:
    // End:0x368 [Loop If]
    if(I < CachedParty.Length)
    {
        CachedParty[I].sStatus = "";
        bIsPartyLeader = CachedParty[I].sName == PartyLeaderName;
        // End:0x2FE
        if(bIsPartyLeader && Len(PartyLeaderIconRef) > 0)
        {
            CachedParty[I].sPartyIcon = "img://" $ PartyLeaderIconRef;
        }
        // End:0x35A
        else
        {
            // End:0x35A
            if(!bIsPartyLeader && Len(PartyMemberIconRef) > 0)
            {
                CachedParty[I].sPartyIcon = "img://" $ PartyMemberIconRef;
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0x224;
    }
    // End:0x5A3
    if(class'FoxDataStore_StoreData'.static.GetCachedFriends(FriendCache))
    {
        CachedFriends = FriendCache.GetDisplayedFriendInfo();
        I = 0;
        J0x3C7:
        // End:0x5A3 [Loop If]
        if(I < CachedFriends.Length)
        {
            J = 0;
            J0x3EA:
            // End:0x595 [Loop If]
            if(J < CachedParty.Length)
            {
                // End:0x587
                if(CachedFriends[I].sName == CachedParty[J].sName)
                {
                    CachedParty[J].sStatus = CachedFriends[I].sStatus;
                    CachedParty[J].Password = CachedFriends[I].Password;
                    CachedParty[J].OnlineStatus = CachedFriends[I].OnlineStatus;
                    CachedParty[J].RoomId = CachedFriends[I].RoomId;
                }
                ++ J;
                // [Loop Continue]
                goto J0x3EA;
            }
            ++ I;
            // [Loop Continue]
            goto J0x3C7;
        }
    }
    as_UpdatePartyList(CachedParty);
    //return;    
}

function ei_SetupSearchPlayerList()
{
    //return;    
}

function OnPartyChanged()
{
    CachedParty = PartyCache.GetPartyList();
    RefreshPartyList();
    //return;    
}

event ToggleSort(int Direction)
{
    PrevSortByMethod = (PrevSortByMethod + Direction) % 2;
    SortPartyList();
    //return;    
}

function SortPartyList()
{
    switch(PrevSortByMethod)
    {
        // End:0x2D
        case 0:
            ei_SortMembersByName(PrevSortByMode);
            // End:0x4A
            break;
        // End:0x47
        case 1:
            ei_SortMembersByRank(PrevSortByMode);
            // End:0x4A
            break;
        // End:0xFFFF
        default:
            OnPartyChanged();
            //return;
    }    
}

function ei_SortMembersByName(int SortMode)
{
    switch(SortMode)
    {
        // End:0x41
        case 0:
            CachedParty.Sort(SortMembersByNameAscending);
            // End:0x72
            break;
        // End:0x6F
        case 1:
            CachedParty.Sort(SortMembersByNameDescending);
            // End:0x72
            break;
        // End:0xFFFF
        default:
            NameSortButton.SetInt("_alpha", SortedByButtonAlpha);
            RankSortButton.SetInt("_alpha", NonSortedByButtonAlpha);
            PrevSortByMethod = 0;
            PrevSortByMode = SortMode;
            as_UpdatePartyList(CachedParty);
            //return;
    }    
}

function ei_SortMembersByRank(int SortMode)
{
    switch(SortMode)
    {
        // End:0x41
        case 0:
            CachedParty.Sort(SortMembersByRankAscending);
            // End:0x72
            break;
        // End:0x6F
        case 1:
            CachedParty.Sort(SortMembersByRankDescending);
            // End:0x72
            break;
        // End:0xFFFF
        default:
            NameSortButton.SetInt("_alpha", NonSortedByButtonAlpha);
            RankSortButton.SetInt("_alpha", SortedByButtonAlpha);
            PrevSortByMethod = 1;
            PrevSortByMode = SortMode;
            as_UpdatePartyList(CachedParty);
            //return;
    }    
}

function int SortMembersByNameAscending(const PartyDisplayInfo LHS, const PartyDisplayInfo RHS)
{
    local string LName, RName;

    // End:0x8B
    if(LHS.AcceptStatus != RHS.AcceptStatus)
    {
        return ((LHS.AcceptStatus < RHS.AcceptStatus) ? 0 : -1);
    }
    // End:0x10B
    if(LHS.OnlineStatus != RHS.OnlineStatus)
    {
        return LHS.OnlineStatus - RHS.OnlineStatus;
    }
    LName = Caps(LHS.sName);
    RName = Caps(RHS.sName);
    return ((LName <= RName) ? 0 : -1);
    //return ReturnValue;    
}

function int SortMembersByNameDescending(const PartyDisplayInfo LHS, const PartyDisplayInfo RHS)
{
    local string LName, RName;

    // End:0x8B
    if(LHS.AcceptStatus != RHS.AcceptStatus)
    {
        return ((LHS.AcceptStatus < RHS.AcceptStatus) ? 0 : -1);
    }
    // End:0x10B
    if(LHS.OnlineStatus != RHS.OnlineStatus)
    {
        return LHS.OnlineStatus - RHS.OnlineStatus;
    }
    LName = Caps(LHS.sName);
    RName = Caps(RHS.sName);
    return ((LName >= RName) ? 0 : -1);
    //return ReturnValue;    
}

function int SortMembersByRankAscending(const PartyDisplayInfo LHS, const PartyDisplayInfo RHS)
{
    // End:0x8B
    if(LHS.AcceptStatus != RHS.AcceptStatus)
    {
        return ((LHS.AcceptStatus < RHS.AcceptStatus) ? 0 : -1);
    }
    // End:0x10B
    if(LHS.OnlineStatus != RHS.OnlineStatus)
    {
        return LHS.OnlineStatus - RHS.OnlineStatus;
    }
    return ((int(LHS.sLevel) <= int(RHS.sLevel)) ? 0 : -1);
    //return ReturnValue;    
}

function int SortMembersByRankDescending(const PartyDisplayInfo LHS, const PartyDisplayInfo RHS)
{
    // End:0x8B
    if(LHS.AcceptStatus != RHS.AcceptStatus)
    {
        return ((LHS.AcceptStatus < RHS.AcceptStatus) ? 0 : -1);
    }
    // End:0x10B
    if(LHS.OnlineStatus != RHS.OnlineStatus)
    {
        return LHS.OnlineStatus - RHS.OnlineStatus;
    }
    return ((int(LHS.sLevel) >= int(RHS.sLevel)) ? 0 : -1);
    //return ReturnValue;    
}

function SetupDelegates()
{
    PartyCache.__OnPartyChanged__Delegate = SortPartyList;
    SetUpFindPlayerDelegates();
    //return;    
}

function ClearDelegates()
{
    PartyCache.__OnPartyChanged__Delegate = None;
    ClearFindPlayerDelegates();
    //return;    
}

function ApplyContextMenuEntry(FoxSocialCategoryParty.EPartyMemberClickMenuOption OptionID, string Label, optional string ToolTip, optional bool bEnabled)
{
    local int Index;

    bEnabled = true;
    // End:0x179
    if(bEnabled)
    {
        Label = Outer.SocialLocalize(Label);
        // End:0x87
        if(ToolTip != "")
        {
            ToolTip = Outer.SocialLocalize(ToolTip);
        }
        Index = ContextMenuEntries.Length;
        ContextMenuEntries.Length = ContextMenuEntries.Length + 1;
        ContextMenuEntries[Index].OptionID = OptionID;
        ContextMenuEntries[Index].sLabel = Label;
        ContextMenuEntries[Index].sTooltip = ToolTip;
        ContextMenuEntries[Index].bDisabled = !bEnabled;
    }
    //return;    
}

function ei_partyMemberOptionClicked(string UnusedArg, string IndexStr)
{
    local int MenuOption;

    // End:0x1FF
    if(ContextMenu != none)
    {
        MenuOption = ContextMenu.GetMenuOptionID(int(IndexStr));
        Outer.Outer.Outer.HideContextMenuWidget(ContextMenu);
        Outer.Outer.Outer.Advance(0.0);
        switch(MenuOption)
        {
            // End:0x116
            case 0:
                ei_partyMemberInventoryButtonClicked("OnlineProfile");
                // End:0x1FF
                break;
            // End:0x136
            case 4:
                ei_partyMemberInventoryButtonClicked("InviteToClan");
                // End:0x1FF
                break;
            // End:0x153
            case 2:
                ei_partyMemberInventoryButtonClicked("JoinMatch");
                // End:0x1FF
                break;
            // End:0x174
            case 3:
                ei_partyMemberInventoryButtonClicked("SpectateMatch");
                // End:0x1FF
                break;
            // End:0x191
            case 5:
                ei_partyMemberInventoryButtonClicked("AddFriend");
                // End:0x1FF
                break;
            // End:0x1FC
            case 1:
                // End:0x1DF
                if(class'WorldInfo'.static.IsConsoleBuild(8))
                {
                    ei_partyMemberInventoryButtonClicked("SendGameInviteOutOfGame");
                }
                // End:0x1F9
                else
                {
                    ei_partyMemberInventoryButtonClicked("SendGameInvite");
                }
                // End:0x1FF
                break;
            // End:0xFFFF
            default:
            }
            //return;            
}

function ei_partyMemberInventoryButtonClicked(string Arg)
{
    local PartyDisplayInfo ClickedMember;
    local PlayerDisplayInfo BaseInfo;

    ClickedMember = CachedParty[ClickedMemberIndex];
    switch(Arg)
    {
        // End:0xFFFF
        default:
            BaseInfo = GetPlayerDisplayFromParty(ClickedMember);
            InventoryButtonClicked(BaseInfo, Arg, true);
            J0x70:
            // End:0x70
            break;
    }
    //return;    
}

event JoinSelectedPartyMemberGame()
{
    // End:0x12F
    if(((RolledOverMemberIndex >= 0) && CachedParty[RolledOverMemberIndex].OnlineStatus > 0) && CachedParty[RolledOverMemberIndex].OnlineStatus != 1)
    {
        // End:0x12F
        if(((CachedParty[RolledOverMemberIndex].OnlineStatus == 8) || CachedParty[RolledOverMemberIndex].OnlineStatus == 10) && !CachedParty[RolledOverMemberIndex].bRankedMatch)
        {
            ClickedMemberIndex = RolledOverMemberIndex;
            ei_partyMemberInventoryButtonClicked("JoinMatch");
        }
    }
    //return;    
}

event ViewSelectedPartyMemberOnlineProfile()
{
    // End:0x3B
    if(RolledOverMemberIndex >= 0)
    {
        ClickedMemberIndex = RolledOverMemberIndex;
        ei_partyMemberInventoryButtonClicked("OnlineProfile");
    }
    //return;    
}

function string as_AddPartyList(int XPos, int YPos, string ClickInterface)
{
    return Outer.Outer.Outer.ActionScriptString("_root.addPartyList");
    //return ReturnValue;    
}

function as_UpdatePartyList(array<PartyDisplayInfo> Friends)
{
    Outer.Outer.Outer.ActionScriptVoid(PartyListPath $ ".updateDataProvider");
    //return;    
}

defaultproperties
{
    PartyMemberIconRef="Menu.t_clanOfficer"
    PartyLeaderIconRef="Menu.t_clanLeader"
    SortedByButtonAlpha=100
    NonSortedByButtonAlpha=50
}